'
'MyPics
'SJJ Embedded Micro Solutions
'Copyright (c) 2004-2008 SJJ Embedded Micro Solutions,LLC  All Rights Reserved
'www.sjjmicro.com
'
'Note: A VB.NET example of a picture viewer gadget

Imports System
Imports System.Drawing
Imports System.IO
Imports System.Reflection
Imports Microsoft.SideShow
Imports Microsoft.SideShow.SimpleContentFormat

Module Module1



    Dim MyPics_GUID As New Guid("{F2E037B2-3EA4-4f69-8E14-DBC9921A69B8}")

    Sub Main(ByVal args() As String)

        If (args.Length = 0) Then
            Console.WriteLine("MyPics Gadget [/R] [/U] [/D]")
            Console.WriteLine("   /R   Register the Gadget")
            Console.WriteLine("   /U   Unregister the Gadget")
            Console.WriteLine("   /D   Download Data")
            'Comment the next line when debugging
            Return

        End If

        For Each arg As String In args

            Select Case arg.ToUpper


                Case "/R" 'Registers the Gadget and sets the location for execution and an icon. You can change these to fit your system
                    GadgetRegistration.Register(False, MyPics_GUID, ScfSideShowGadget.ScfEndpointId, "MyPics", "C:\dotNETMF\SideShow\Samples\MyPics\MyPics\bin\Debug\Mypics.exe /D", "C:\dotNETMF\SideShow\Samples\MyPics\MyPics\bin\Debug\camera.ico", False, GadgetCachePolicies.KeepNewest, Nothing)

                Case "/U"
                    GadgetRegistration.Unregister(False, MyPics_GUID)

                Case "/D"
                    DownloadPics()

                Case "?"
                    Console.WriteLine("MyPics Gadget [/R] [/U] [/D]")
                    Console.WriteLine("   /R   Register the Gadget")
                    Console.WriteLine("   /U   Unregister the Gadget")
                    Console.WriteLine("   /D   Download Data")
                    Return

            End Select

        Next

        'Uncomment the next line for debugging
        'DownloadData()

    End Sub


    Sub DownloadPics()

        Dim MyPics_Gadget As New ScfSideShowGadget(MyPics_GUID)

        'Get a list of the JPG files in the c:\pictures directory
        Dim PicFiles As String() = Directory.GetFiles("c:\pictures", "*.jpg")

        'Send down the glance data
        MyPics_Gadget.AddGlanceContent(String.Format("There are " + PicFiles.Length.ToString + " pictures downloaded on " + Environment.NewLine + Date.Now.ToString))

        'Setup the First Page
        MyPics_Gadget.AddContent(Scf.Content(1, PicFiles(0), Scf.Img(100, ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, "", 2), Scf.Btn(DeviceButton.Left, "", PicFiles.Length)))
        MyPics_Gadget.AddContent(100, ImageContentTransforms.ReduceColorDepth Or ImageContentTransforms.StretchToFit, Image.FromFile(PicFiles(0)))

        'Add the pages between the first and the last
        For x As Integer = 1 To PicFiles.Length - 2

            MyPics_Gadget.AddContent(Scf.Content((x + 1), PicFiles(x), Scf.Img((100 + x), ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, ">>", (x + 2)), Scf.Btn(DeviceButton.Left, "<<", x)))
            MyPics_Gadget.AddContent((100 + x), ImageContentTransforms.ReduceColorDepth Or ImageContentTransforms.StretchToFit, Image.FromFile(PicFiles(x)))

        Next

        'Setup last page
        MyPics_Gadget.AddContent(Scf.Content(PicFiles.Length, PicFiles(PicFiles.Length - 1), Scf.Img((100 + (PicFiles.Length - 1)), ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, ">>", 1), Scf.Btn(DeviceButton.Left, "<<", (PicFiles.Length - 1))))
        MyPics_Gadget.AddContent((100 + (PicFiles.Length - 1)), ImageContentTransforms.ReduceColorDepth Or ImageContentTransforms.StretchToFit, Image.FromFile(PicFiles(PicFiles.Length - 1)))


    End Sub

End Module
