//
//
//My_Pictures
//SJJ Embedded Micro Solutions
//Copyright (c) 2004-2008 SJJ Embedded Micro Solutions,LLC  All Rights Reserved
//www.sjjmicro.com
//
//
//Notes: This is a C# example of a picutre viewing gadget
//

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Reflection;
using System.Drawing;
using System.ComponentModel;
using System.Diagnostics;
using Microsoft.SideShow;
using Microsoft.SideShow.SimpleContentFormat;

namespace MyPictures
{
    class Program
    {

        private static readonly Guid MyPictureID = new Guid("{19A58941-934C-46d7-BF0B-6A3E9BFBE3CB}");
                
        static void Main(string[] args)
        {
            if (args.Length == 0)
            {
                Console.WriteLine("MyPictures Gadget [/R] [/U] [/D]");
                Console.WriteLine("   /R   Register the MyPictures Gadget");
                Console.WriteLine("   /U   Unregister the the MyPictures Gadget");
                Console.WriteLine("   /D   Download Pictures");
                //return;
            }

            foreach (String arg in args)
            {
           
                switch (arg.ToUpperInvariant())
                {
                    case "/R":   
                        GadgetRegistration.Register(false, MyPictureID, ScfSideShowGadget.ScfEndpointId, "MyPictures Gadget",null, null, false, GadgetCachePolicies.KeepNewest, null);
                        break;

                    case "/U":
                        GadgetRegistration.Unregister(false, MyPictureID);
                        break;

                    case "/D":
                        DownloadPictures();
                        break;

                    case "/?":   // Download data from the gadget to its connected devices
                        Console.WriteLine("MyPictures Gadget  [/R] [/U] [/D]");
                        Console.WriteLine("   /R   Register the MyPictures Gadget");
                        Console.WriteLine("   /U   Unregister the the MyPictures Gadget");
                        Console.WriteLine("   /D   Download Pictures");
                        return;
                        
                    default:
                        
                        break;
                }
            }

            
        }

        static void DownloadPictures()
        {

            String[] PictureFiles = Directory.GetFiles("c:\\Pictures","*.jpg");
            
            ScfSideShowGadget gadget = new ScfSideShowGadget(MyPictureID);

            gadget.AddGlanceContent(String.Format("There are {0} pictures downloaded on {1}{2}",PictureFiles.Length, Environment.NewLine,DateTime.Now));
        
            //Setup the First Page
            gadget.AddContent(Scf.Content(1, PictureFiles[0], Scf.Img(100, ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, ">>", 2), Scf.Btn(DeviceButton.Left, "<<", PictureFiles.Length)));
            gadget.AddContent(100, ImageContentTransforms.ReduceColorDepth | ImageContentTransforms.StretchToFit, Image.FromFile(PictureFiles[0]));
           
            //Setup the pages between the first and the last
            for (int x = 1; x <= (PictureFiles.Length - 2); x++)
            {
         
                gadget.AddContent(Scf.Content((x+1), PictureFiles[x], Scf.Img((100+x), ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, ">>", (x + 2)), Scf.Btn(DeviceButton.Left, "<<", x)));
                gadget.AddContent((100 + x), ImageContentTransforms.ReduceColorDepth | ImageContentTransforms.StretchToFit, Image.FromFile(PictureFiles[x]));
            
            }

            //Setup the Last page
            gadget.AddContent(Scf.Content(PictureFiles.Length, PictureFiles[PictureFiles.Length-1], Scf.Img((100+(PictureFiles.Length-1)), ScfAlign.Center, ScfImageFit.Screen, "picture not there"), Scf.Btn(DeviceButton.Right, ">>", 1), Scf.Btn(DeviceButton.Left, "<<", (PictureFiles.Length - 1))));
            gadget.AddContent((100 + (PictureFiles.Length - 1)), ImageContentTransforms.ReduceColorDepth | ImageContentTransforms.StretchToFit, Image.FromFile(PictureFiles[PictureFiles.Length - 1]));


        }





    }
}
